signature CONTEXT = sig
  type ctxt 

  val upd    : SMLNG.tag * ctxt -> ctxt
  val upd_ws : ctxt -> ctxt

  val isSet  : SMLNG.tag * ctxt -> bool
  val eq     : (ctxt * ctxt) -> bool


  val b      : ctxt -> bool
  val em     : ctxt -> bool
  val i      : ctxt -> bool
  val s      : ctxt -> bool
  val tt     : ctxt -> bool
  val u      : ctxt -> int 
  val size   : ctxt -> int option
  val color  : ctxt -> SMLNG.color option

  val common : (ctxt * ctxt) -> ctxt option
  val init   : ctxt 

  val fold_with_ctxt : {kSeq:('a * 'a) -> 'a,
			kTxt:(ctxt * string) -> 'a,
			kWs:(ctxt * string) -> 'a,
			kNd:(ctxt * SMLNG.tag * 'a) -> 'a} ->
                                     ctxt -> SMLNG.doc -> 'a

  val toTags : ctxt -> SMLNG.tag list
  end

