signature MERGE_ADJACENT = sig
  val go : SMLNG.doc -> SMLNG.doc 
end
structure MergeAdjacent (*:> MERGE_ADJACENT *) =
  struct
    structure T = CDocs
    structure C = Context

    fun merge cdocs = let
      val kTxt = T.Txt
      val kWs = T.Ws
      fun kNd (c,t,(NONE,d)) = T.Nd(c,t,d)
	| kNd (c,x,(SOME y,d)) = T.Nd(c,x,T.One (T.Nd(C.upd (y,c),y,d)))

      fun kOne d = (T.tag d,T.One d)
      fun kCons(c as T.Nd(_,t,_),(NONE,cdocs)) = (SOME t,T.App(T.One c,cdocs))
	| kCons(c as T.Nd(ctxt,x,xs),(SOME y,ys)) =
	 if x = y then (SOME x,T.App(xs,ys))
	 else (SOME x,T.App(xs,T.One(T.Nd(ctxt,y,ys))))
	| kCons(c,(x,cdocs)) = (x,T.App(T.One c,cdocs))
    in T.fold {kOne=kOne, kCons=kCons, kTxt=kTxt, kWs=kWs, kNd=kNd} cdocs
    end
    fun go doc = let
       val cdocs = T.fromDoc doc
       val cdocs = case merge cdocs of
	 (NONE,cdocs) => cdocs
       | (SOME t,cdocs) => T.One(T.Nd(C.init,t,cdocs))
       val doc = T.toDoc cdocs
    in doc
    end

  end
