signature REMOVE_REDUNDANT = sig
  val go : SMLNG.doc -> SMLNG.doc 
end
structure RemoveRedundant :> REMOVE_REDUNDANT =
  struct
    structure T = SMLNG
    structure C = Context
    fun go doc = let
      fun kSeq(x,y) = T.Seq(x,y)
      fun kTxt(c,s) = T.Txt s
      fun kWs(c,s) = T.Ws s
      fun kNd(c,t,d) =
	if Context.isSet(t,c) then d
	else T.Nd(t,d)
    in Context.fold_with_ctxt {kSeq=kSeq,
			       kTxt=kTxt,
			       kWs=kWs,
			       kNd=kNd}
       Context.init doc
    end
  
  end
